<?php
class ControllerExtensionPaymentIpay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/ipay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_ipay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['vendor'])) {
			$data['error_vendor'] = $this->error['vendor'];
		} else {
			$data['error_vendor'] = '';
		}

		if (isset($this->error['hash'])) {
			$data['error_hash'] = $this->error['hash'];
		} else {
			$data['error_hash'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/ipay', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/ipay', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_ipay_vendor'])) {
			$data['payment_ipay_vendor'] = $this->request->post['payment_ipay_vendor'];
		} else {
			$data['payment_ipay_vendor'] = $this->config->get('payment_ipay_vendor');
		}

		if (isset($this->request->post['payment_ipay_hash'])) {
			$data['payment_ipay_hash'] = $this->request->post['payment_ipay_hash'];
		} else {
			$data['payment_ipay_hash'] = $this->config->get('payment_ipay_hash');
		}

		if (isset($this->request->post['payment_ipay_test'])) {
			$data['payment_ipay_test'] = $this->request->post['payment_ipay_test'];
		} else {
			$data['payment_ipay_test'] = $this->config->get('payment_ipay_test');
		}

		$data['callback'] = HTTP_CATALOG . 'index.php?route=extension/payment/ipay/callback';

		if (isset($this->request->post['payment_ipay_total'])) {
			$data['payment_ipay_total'] = $this->request->post['payment_ipay_total'];
		} else {
			$data['payment_ipay_total'] = $this->config->get('payment_ipay_total');
		}

		if (isset($this->request->post['payment_ipay_order_status_id'])) {
			$data['payment_ipay_order_status_id'] = $this->request->post['payment_ipay_order_status_id'];
		} else {
			$data['payment_ipay_order_status_id'] = $this->config->get('payment_ipay_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_ipay_geo_zone_id'])) {
			$data['payment_ipay_geo_zone_id'] = $this->request->post['payment_ipay_geo_zone_id'];
		} else {
			$data['payment_ipay_geo_zone_id'] = $this->config->get('payment_ipay_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_ipay_status'])) {
			$data['payment_ipay_status'] = $this->request->post['payment_ipay_status'];
		} else {
			$data['payment_ipay_status'] = $this->config->get('payment_ipay_status');
		}

		if (isset($this->request->post['payment_ipay_sort_order'])) {
			$data['payment_ipay_sort_order'] = $this->request->post['payment_ipay_sort_order'];
		} else {
			$data['payment_ipay_sort_order'] = $this->config->get('payment_ipay_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/ipay', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/ipay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_ipay_vendor']) {
			$this->error['vendor'] = $this->language->get('error_vendor');
		}

		if (!$this->request->post['payment_ipay_hash']) {
			$this->error['hash'] = $this->language->get('error_hash');
		}

		return !$this->error;
	}
}
