<?php
class ControllerExtensionPaymentIpay extends Controller {
	public function index() {
		$data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		
		$ipay_url 				= 'https://payments.ipayafrica.com/v3/ke';
		//$ipay_url 				= 'https://payments.elipa.co.tz/v3/tz';

	    if($this->config->get('payment_ipay_test') == '1'){
	    	$live = '0';
	    }elseif($this->config->get('payment_ipay_test') == '0'){
	    	$live = '1';
	    }else{
	    	$live = '';
	    }
	    
	    $mm		= 1;
	    $mb		= 1;
	    $dc		= 1;
	    $cc		= 1;
		
		$oid 	= $order_info['order_id'];
    	$inv 	= $order_info['invoice_prefix'];
		$ttl 	= $order_info['total'];
		$tel 	= $order_info['telephone'];
		$eml 	= $order_info['email'];


	   	/**
	   	 * incase of any dashes in the telephone number the code below removes them
	   	 * @var [string]
	   	 */
	    $tel 	= str_replace("-", "", $tel);
	    $tel 	= str_replace( array(' ', '<', '>', '&', '{', '}', '*', "+", '!', '@', '#', "$", '%', '^', '&'), "", $tel );
	    
	    $vid	= $this->config->get('payment_ipay_vendor');
	    //$this->console_log($vid);
	    $curr	= $order_info['currency_code'];
	    
	    /**
	     * $p1, $p2, $p3, $p4  are optional fields. Allow sending & receiving your custom parameters
	     * Each option should not exceed 20 characters.
	     */
	    $p1		= '';
	    $p2 	= '';
	    $p3 	= ''; 
	    $p4 	= '';
	    

	    /**
	     * [$callbk holds the callback URL]
	     */
	    $callbk = $this->url->link('extension/payment/ipay/callback', '', true);
	    
	    $cst 	= 1;
	    $crl 	= 0;

		/*
		* Plugin Identifier
		*/
		$channel = "OpenCart";

		/**
		 * Mandatory Channels
		 */
		$bonga = '1';
		$vooma = '1';
	    
	    /**
	     * [$hsh holds the merchant's secret key]
	     */
	    $hsh = $this->config->get('payment_ipay_hash');
	    
	    //The data string values
	    $datastring =$live.$oid.$inv.$ttl.$tel.$eml.$vid.$curr.$p1.$p2.$p3.$p4.$callbk.$cst.$crl;

	    //Setting the hashing algorithm to SHA1
	    $hashid = hash_hmac('sha1', $datastring, $hsh);

	    /*URLENCODE*/
	    $cbk = urlencode($callbk);

	    $data['url'] = $ipay_url.'?live='.$live.'&oid='.$oid.'&inv='.$inv.'&ttl='.$ttl.'&tel='.$tel.'&eml='.$eml.'&vid='.$vid.'&p1='.$p1.'&p2='.$p2.'&p3='.$p3.'&p4='.$p4.'&crl='.$crl.'&cbk='.$cbk.'&cst='.$cst.'&curr='.$curr.'&hsh='.$hashid.'&channel='.$channel."&bonga=".$bonga."&vooma=".$vooma;

		return $this->load->view('extension/payment/ipay', $data);
	}

	public function callback() {
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		/**
		 * these values below are picked from the incoming URL and assigned to variables
		 * that wewill use in our security check URL
		 *
		 * The value of the parameter “vendor”, in the url being opened above, is your iPay assigned Vendor ID
		 */
		$request	= 'vendor='.urlencode($this->config->get('payment_ipay_vendor'));
		$request 	.= '&id='.urlencode($this->request->get['id']);
		$request	.= '&ivm='.urlencode($this->request->get['ivm']);
		$request	.= '&qwh='.urlencode($this->request->get['qwh']);
		$request	.= '&afd='.urlencode($this->request->get['afd']);
		$request	.= '&poi='.urlencode($this->request->get['poi']);
		$request	.= '&uyt='.urlencode($this->request->get['uyt']);
		$request	.= '&ifd='.urlencode($this->request->get['ifd']);


		$ipnurl 	= "https://www.ipayafrica.com/ipn/?".$request;


		/**
		 * If the payment mode is LIVE, it gets the payment status.
		 * If the plugin is on test mode, it always gives a successful response.
		 */
		if($this->config->get('payment_ipay_test') === '0'){

			$fp 		= fopen($ipnurl, "rb");
			$response	= stream_get_contents($fp, -1, -1);
			fclose($fp);

		}elseif($this->config->get('payment_ipay_test') === '1'){
			$response 	= "aei7p7yrx4ae34";
		}


		$order_id		= $this->session->data['order_id'];
		$this->load->model('checkout/order');

		
		/**
		 * Success
		 * The transaction is valid. Therefore you can update this transaction.
		 */
		if ($response === 'aei7p7yrx4ae34') {

			if (isset($this->session->data['order_id'])) {

				$order_id = $this->session->data['order_id'];
			}else{
				echo "The system could not capture the order ID. Kindly refresh the page";
			}

			$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_ipay_order_status_id'));
			// $this->console_log($this->config->get('payment_ipay_order_status_id'));
			$this->response->redirect($this->url->link('checkout/success'));

		} 


		/**
		 * Pending
		 * Incoming Mobile Money Transaction Not found. The user should try again after 5 Minutes.
		 */
		elseif ($response === 'bdi6p2yy76etrs') {
			$data['message'] = "Incoming Mobile Money Transaction Not found.";			
		}


		/**
		 * Used:
		 * This code has been used already. A notification of this transaction sent to the merchant.
		 */
		elseif ($response === 'cr5i3pgy9867e1') {
			$data['message'] = "This code has been used already.";
		}


		/**
		 * More
		 * The amount that you have sent via mobile money is MORE than what was required to validate this transaction
		 */
		elseif ($response === 'eq3i7p5yt7645e') {
			$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('payment_ipay_order_status_id'));
			
			$data['message'] = 'More: The amount that you have sent via mobile money is MORE than what was required to validate this transaction.';
			
			$this->model_checkout_order->update($this->session->data['order_id'], $this->config->get('payment_ipay_order_status_id'), $message, false);				
		
		}


		/**
		 * Less
		 * The amount that you have sent via mobile money is LESS than what was required to validate
		 */
		elseif ($response === 'dtfi4p7yty45wq') {

			$data['message'] = " Less: The amount that you have sent via mobile money is LESS than what was required to validate this transaction. ";	
		}


		/**
		 * Failed transaction
		 * Not all parameters fulfilled. A notification of this transaction sent to the merchant.
		 */
		elseif ($response === 'fe2707etr5s4wq') {
			
			$this->response->redirect($this->url->link('checkout/checkout'));
		}
	}


	// public function console_log( $data ){

	//         echo '<script>';
	//         echo 'console.log('. json_encode( $data ) .')';
	//         echo '</script>';
	//     }
}
